# calculate the eigen decomposition of WG^TPGW
# see Eq 2.10 of Wu et al. 2017, AOAS

calculateLambda_Wmat <- function(W, G, SinvP0Sinv) # W: matrix
{
  nsnp <- ncol(G)
  if ((nrow(W) != nsnp) || (ncol(W) != nsnp))
  {
    stop("# of SNPs from W and G do not match!")
  }
  nind <- nrow(G)
  if ((nrow(SinvP0Sinv) != nind) || (ncol(SinvP0Sinv) != nind))
  {
    stop("# of individuals from SinvP0Sinv and G do not match!")
  }
  
  GW <- G %*% W
  WGtSinvP0SinvGW <- t(GW) %*% SinvP0Sinv %*% GW
  Lambda <- eigen(WGtSinvP0SinvGW)$values
  
  return(list(WGtSinvP0SinvGW = WGtSinvP0SinvGW, Lambda = Lambda))
}
